//ATMega168-20  20.0MHz external clock
//RS170eXgvO
//2007.7.18  

//FAVRStudio4 Ver4.12 SP4 Build498
//RpCFWinAVR-20060421
//C^[FAVRISP-mk2

//q[YrbgF0xF9 0xDF 0xDF

//F


#include <avr/io.h>
#include <avr/interrupt.h>
#include <util/delay.h>			//F_CPÚAProject Options  FrequencyŕKݒ肵Ă

#define VIDEO_PORT			PORTC
#define VIDEO_PORT_DDR		DDRC		
#define VIDEO_BIT_R0		0		//R0 bitw(0-7)
#define VIDEO_BIT_R1		1		//R1 bitw(0-7)
#define VIDEO_BIT_R2		2		//R2 bitw(0-7)

//#define RS170_CLK	3579545L	//hbgNbN 3.58MHz
#define RS170_H		63.56e-6	// 63.56ʂ

#define FIRST_LINE	21			//fԍŏ̃C
#define END_LINE	262			//fԍŌ̃C

#define LV0		(1<<VIDEO_BIT_R0)
#define LV1	    (1<<VIDEO_BIT_R1)
#define LV2	    (1<<VIDEO_BIT_R2)

const unsigned char LV_WHITE = LV2 | LV1 | LV0;
const unsigned char LV_GRAY2 = LV2       | LV0;
const unsigned char LV_GRAY1 =       LV1 | LV0;
const unsigned char LV_BLACK =             LV0;
const unsigned char LV_ALL   = LV2 | LV1 | LV0;

const unsigned int H_CYCLE = F_CPU * RS170_H - 1;	//ԃTCN
const unsigned int H_CYCLE_HARF = (F_CPU * RS170_H)/2 - 1;	//1/2 ԃTCN
const unsigned int d2_3u = (F_CPU * 2.3e-6)/4 - 1;    //2.3ʃTCN
const unsigned int d29_48u = (F_CPU * 29.48e-6)/4 - 1;//29.48ʃTCN
const unsigned int d27_08u = (F_CPU * 27.08e-6)/4 - 22;//27.08ʃTCN
const unsigned int d4_7u = (F_CPU * 4.7e-6)/4-1;    //4.7ʃTCN
const unsigned int d58_86u = (F_CPU * 58.86e-6)/4 - 22;//58.86ʃTCN

volatile int LineCount;//荞ݒŎgp郉CJEg

void delay_us(unsigned int us)
{
	while(us--){
		_delay_us(1);//傫ȎԂ͍Ȃ̂ŁAłPʂ̃[vɂ
	}
}

void delay_ms(unsigned int us)
{
	while(us--){
		_delay_ms(1);//傫ȎԂ͍Ȃ̂ŁAłP̃[vɂ
	}
}

void delay_x4( unsigned int count )
{
	//PJEgSTCÑCCAZu[v
	asm __volatile__("\n\t"
      "L1: sbiw %0,1"	"\n\t"
      "brne L1"  "\n\t"
      : "=w"(count)
      : "0"(count));
}

//INTERRUPT(SIG_OUTPUT_COMPARE1A)

//Pg̊荞݁iJE^[PRyA}b``j
SIGNAL(SIG_OUTPUT_COMPARE1A)
{
	static char patarn = 2;

	//C
	if(LineCount==1) patarn = 0;
	if(LineCount==4) patarn = 1;
	if(LineCount==7) patarn = 0;
	if(LineCount==10) patarn = 2;

	//Mo
	switch(patarn){
		case 0://uuLO
		{				
			VIDEO_PORT &= ~LV_ALL;//dOu
			delay_x4(d2_3u);
			VIDEO_PORT = LV_BLACK;//dO.Ru
			break;
		}
		case 1://urxmb
		{				
			VIDEO_PORT &= ~LV_ALL;//dOu
			delay_x4(d58_86u);
			VIDEO_PORT = LV_BLACK;//dO.Ru
			break;
		}
		case 2://grxmb
		{				
			VIDEO_PORT &= ~LV_ALL;//dOu
			delay_x4(d4_7u);
			VIDEO_PORT = LV_BLACK;//dO.Ru
			break;
		}
		default://ɂ́AȂ͂
		{
			VIDEO_PORT &= ~LV_ALL;//dOu
			delay_x4(d4_7u);
			VIDEO_PORT = LV_BLACK;//dO.Ru
			break;
		}
	}

	//tB[hIACJE^Pɖ߂
	if(LineCount==263) LineCount=1;
	else LineCount++;//CJE^XV
}

int main()
{
	int x,y,y0;
	int oldLine;
	int disp_start_line;
	char c[16][16] = {//16x16hbg̃J^JíuCv
	 "0000000000011111",
	 "0000000000111110",
	 "0000000001111100",
	 "0000000011111000",
	 "0000001111110000",
	 "0000111111100000",
	 "0011111011100000",
	 "1111000011100000",
	 "0000000011100000",
	 "0000000011100000",
	 "0000000011100000",
	 "0000000011100000",
	 "0000000011100000",
	 "0000000011100000",
	 "0000000011100000",
	 "0000000001000000",
	};
	
	//IO pin 
    VIDEO_PORT_DDR = (1<<VIDEO_BIT_R2) | (1<<VIDEO_BIT_R1) | (1<<VIDEO_BIT_R0);//PORT (1:out 0:in)

	//^C}[ݒ
	TCCR1A = 0;         	// ftHg
	TCCR1B = (1<<WGM12) | (1<<CS10);     // RyAvɂăJE^NAA
	TIMSK1 = (1<<OCIE1A);	// RyA}b``荞݋
	SMCR = (1<<SE);     	// X[vCl[u
    OCR1A = H_CYCLE;		// RyAlZbgiPgԁj

	//ϐ
	LineCount = 1;
	oldLine = -1;
	x = 0;
	y = 0;
	y0 = 0;
	disp_start_line = FIRST_LINE + 80;//̃C\Jn

	sei();               	// 荞݋

	//main loop
	while(1) {
	    asm __volatile__("sleep"::);//X[vJn([v~)

		//荞݂IƂJni[vĊJj
	
		if(LineCount < FIRST_LINE || END_LINE < LineCount) continue;//fԊÕCł͈ȉ͎sȂ

		//f 21-262 Line

		if((disp_start_line <= LineCount)
			 && (LineCount < (disp_start_line + 16*6))){//\C

			delay_us(18);//̈ʒu

			for(x=0;x<16;x++){
				if(c[y][x]=='1') {
					VIDEO_PORT = LV_WHITE;
				}
				else{
					VIDEO_PORT = LV_BLACK;
				}
			}
			VIDEO_PORT = LV_BLACK;

			if(LineCount != oldLine) y0++;
			if(y0>=6){//LineCountUCɕtHg̍PhbgXV
				y++;
				if(y>=16) y=0;
				y0 = 0;
			}


		}//\C end

		oldLine=LineCount;

		//PgI鏭OSleepɂǂKv
	} //main loop end

	return 0;
}
